#! /usr/local/bin/perl

######################################################################
# tofu.pl  -  ΥȡղPerlǡ
# Copyright (C) 1978 - 2000 by Nobuhide Tsuda
# --------------------------------------------------------------------
# PerlǸTheMatrix⡼ɡʥץ -matrix
#   -- ʸäФƤޤ
# ˡpodޥ˥奢򻲾ȤƤ
######################################################################

use strict;
use vars qw( $matrix );

sub max($$) { return $_[0] >= $_[1] ? $_[0] : $_[1]; }
sub min($$) { return $_[0] <= $_[1] ? $_[0] : $_[1]; }
sub println(@) { print @_, "\n"; }
sub millisleep($) { select(undef, undef, undef, $_[0] / 1000); }
sub random100() { return int(rand 101); } # 0 - 100

# TheMatrixäɽ
sub disp(@) {
    if ($matrix) {
	foreach my $char (split(//, join("", @_))) {
	    print($char); millisleep(25);
	}
    }
    else { print(@_); }
}
sub displn(@) { disp(@_, "\n"); }

# ԥ塼¦׹ͥ롼ƥ
sub calc($$$$) {
    my($comp, $hare, $kumori, $ame) = @_;
    return min(int($comp / 40),
	       ($hare >= 50 ? 500 : ($ame > 30 ? 100 : 300)));
}

# 롼ɽ
sub dispRule() {
    disp(<<'RULE');

ϥʤϤǥȡղбĤ
ϵؤεѤФʤƤϤޤ
Ǥ⤪ˤϡԥ塼бĤȡղޤ

ȡդθϣģߡʤϣߤǤ
Ŀŷ˺ޤ
ȣġȣġΤȤϣĤޤޤ
ȡդʤΤǡĤäʬϤ٤Ѵޤ
ǡŷͽ褯ơĺ뤫迴Ƥ
⣵ߤϤ᤯ߤĶǤ

RULE
}

# ɽ
sub dispShojikin($$) {
    my($name, $gold) = @_;
    disp("  ", $name, sprintf(" %6d   ", $gold));
    my $i = 1000;  my $g = "";
    for (; $i <= $gold; $i += 1000) { $g .= ""; }
    for (; $i <= 30000; $i += 1000) { $g .= ""; }
    println($g);
    #displn($g);
}

# ͽ׻
sub yohou() {
    my $prob1 = random100();
    my $prob2 = random100();
    my $hare = 100 - max($prob1, $prob2);
    my $ame = min($prob1, $prob2);
    my $kumori = 100 - $hare - $ame;
    return($hare, $kumori, $ame);
}

# ͽɽ
sub dispYohou($$$) {
    my($hare, $kumori, $ame) = @_;
    displn("\nŷͽ ",
	   " ${hare}%   ${kumori}%   ${ame}%");
    my $i = 25;  my $g = "";
    for (; $i <= $hare * 10; $i += 25)             { $g .= ""; }
    for (; $i <= ($hare + $kumori) * 10; $i += 25) { $g .= ""; }
    for (; $i <= 1000; $i += 25)                   { $g .= ""; }
    println($g);
    #displn($g);
}

# ᥤ
$| = 1;
srand( time() ^ ($$ + ($$ << 15)) ); # 
$matrix = 1 if ($ARGV[0] =~ /\-matrix/i); # TheMatrix⡼
disp("ΥȡղPerlǡ\n",
     "Copyright (c) 1978 - 2000 by Nobuhide Tsuda\n\n",
     "롼ޤ[y/n] ");
my $res = <STDIN>;
dispRule() if ( $res =~ /^[yY]/ );

for(;;) {			# 
    my $player = 5000;
    my $comp = 5000;

    for(;;) {
	displn("\n⡧");
	dispShojikin("ʤ", $player);
	dispShojikin("錄", $comp);
	last if ( $player >= 30000 || $comp >= 30000 );

	my($hare, $kumori, $ame) = yohou();
	dispYohou($hare, $kumori, $ame);

	my $limit = int($player / 40);
	disp("\nȡդ򲿸ĺޤʣ${limit}\n> ");
	my $pn;
	for(;;) {
	    $pn = <STDIN>;
	    last if( $pn > 0 && $pn <= $limit );
	}

	my $cn = calc($comp, $hare, $kumori, $ame);
	displn("錄 ${cn} ޤ\n");
	millisleep(500);

	displn("  ");
	my $r = random100();
	my($tenki, $sold);
	if ( $r <= $ame ) {
	    $tenki = "   (;_;) ";
	    $sold = 100;
	}
	elsif ( $r <= $ame + $kumori ) {
	    $tenki = "   (~_~) ";
	    $sold = 300;
	}
	else {
	    $tenki = "  (^o^) ";
	    $sold = 500;
	}
	disp("ŷ");
	for(my $i = 0; $i < 3; ++ $i) {
	    millisleep(250);
	    disp(".");
	}
	millisleep(250);
	displn("${tenki} Ǥ");
	$player += min($sold, $pn) * 50 - $pn * 40;
	$comp += min($sold, $cn) * 50 - $cn * 40;
	millisleep(500);
    }

    if( $player > $comp ) {
	displn("\nʤξǤ");
    }
    elsif ( $player == $comp ) {
	displn("\nʬǤ");
    }
    else {
	displn("\nԥ塼ξǤ");
    }
    disp("\nplay again ? [y/n] ");
    $res = <STDIN>;
    last if ( $res =~ /^[nN]/ );
}

# ----------------------------------------------------------------------

=head1 NAME

tofu.pl - Υȡղ Perl

=head1 SYNOPSIS


Ŀ֥ΥȡղפPerlǤǤǥȡղбĤȤܽʣǯˤηбĥߥ졼󥲡Ǥȡդäϵ˵뤿ι̤ޤPerl5ʾư뤳ȤտޤƤޤưǧSolaris, Linux, FreeBSDPerl 5.005ǹԤޤ

=head1 HOW TO PLAY

¹Ԥȥ롼ɽ뤫ɤʹƤޤ򻲾ȤƤ

ޤư -matrix ץꤹȡTheMatrix⡼ɤͷ֤ȤǤޤäȤСʴǤ󤪻

=head1 COPYRIGHT

Perlؤΰܿϱ (gano@is.s.u-tokyo.ac.jp) ԤޤViViScriptǤΥ򻲹ͤˤƤޤĿ (ntsuda@beam.ne.jp) ˤޤ

ΥȡղPerlǤϥե꡼եȤǤꡢץ󥽡Ǥץपӥ̵ǥԡդ뤳ȤǤޤѤ˺ݤԶΤäƤ⸶ԡܿԤϤʤݾԤʤޤ󡣤餫λ

=head1 SEE ALSO

֥Υȡղ׸ڡ
http://www1.beam.ne.jp/ntsuda/tofu.htm

ǲ TheMatrix ܸڡ
http://japan.whatisthematrix.com/

=cut

# [EOF]
